package com.kingdee.eas.custom.ssPDF.utils;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;


public class HttpClient3 {
    public static byte[] getBytesByNetURL(String urlStr) throws IOException {
//		RestTemplate restTemplate = new RestTemplate();
//		ResponseEntity<byte[]> responseEntity = restTemplate.exchange(urlStr, HttpMethod.GET, null, byte[].class);
//		byte[] fileContent = responseEntity.getBody();
        URL url = new URL(urlStr);
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
//		//óʱʱ
        conn.setConnectTimeout(5 * 1000);
//		//ͨȡͼƬ
        InputStream in = conn.getInputStream();
//		//õͼƬĶ
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        byte[] buffer = new byte[1024];
        int len;
        while ((len = in.read(buffer)) != -1) {
            outputStream.write(buffer, 0, len);
        }
        in.close();
        return outputStream.toByteArray();
//		return fileContent;
    }
    /**
     * http get
     * @param httpUrl 
     * @return Ӧ
     */
    public static InputStream doGet(String httpUrl){
        //
        HttpURLConnection connection=null;
        InputStream is=null;
        BufferedReader br = null;
        StringBuffer result=new StringBuffer();
        try {
            //
            URL url=new URL(httpUrl);
            connection= (HttpURLConnection) url.openConnection();
            //ʽ
            connection.setRequestMethod("GET");
            //ӳʱʱ
            connection.setConnectTimeout(15000);
            //öȡʱʱ
            connection.setReadTimeout(15000);
            //ʼ
            connection.connect();
            //ȡӦ
            if(connection.getResponseCode()==200){
                //ȡص
                is=connection.getInputStream();

//                if(is!=null){
//                    br=new BufferedReader(new InputStreamReader(is,"UTF-8"));
//                    String temp = null;
//                    while ((temp=br.readLine())!=null){
//                        result.append(temp);
//                    }
//                }
            }
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            if(br!=null){
                try {
                    br.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if(is!=null){
                try {
                    is.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            connection.disconnect();// رԶ
        }

        return is;
    }

    /**
     * post
     * @param httpUrl 
     * @param param 
     * @return
     */
    public static JSONObject doPost(String httpUrl,  String param) {
        StringBuffer result=new StringBuffer();
        //
        HttpURLConnection connection=null;
        OutputStream os=null;
        InputStream is=null;
        BufferedReader br=null;
        JSONObject jsonObject = null;
        try {
            //Ӷ
            URL url=new URL(httpUrl);
            //
            connection= (HttpURLConnection) url.openConnection();
            //󷽷
            connection.setRequestMethod("POST");
            //ӳʱʱ
            connection.setConnectTimeout(15000);
            //öȡʱʱ
            connection.setReadTimeout(15000);
            //Ƿɶȡ
            connection.setDoOutput(true);
            //ӦǷɶȡ
            connection.setDoInput(true);
            //ò
            connection.setRequestProperty("Content-Type", "application/json");
            //ƴװ
            if(param!=null&&!param.equals("")){
                //ò
                os=connection.getOutputStream();
                //ƴװ
                os.write(param.getBytes("UTF-8"));
            }
            //Ȩ
            //ͷ

            //
            //connection.connect();
            //ȡӦ
            if(connection.getResponseCode()==200){
                is=connection.getInputStream();
                if(is!=null){
                    br=new BufferedReader(new InputStreamReader(is,"UTF-8"));
                    String temp=null;
                    if((temp=br.readLine())!=null){
                        result.append(temp);
                    }
                }
                 jsonObject =  JSON.parseObject(String.valueOf(result));

            }
            //ر
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            if(br!=null){
                try {
                    br.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if(os!=null){
                try {
                    os.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if(is!=null){
                try {
                    is.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            //ر
            connection.disconnect();
        }
        return jsonObject;
    }


    public static void main(String[] str){
        /*String result=HttpURLConnectionUtil.doGet("http://localhost:8080/test");
        System.out.println(result);*/
        /*Map<String, Object> map=new HashMap<>();
        map.put("1","1");
        map.put("2","2");
        map.put("3","3");
        System.out.println(HttpURLConnectionUtil.getParamStr(map));*/
    }
}