;(function ($) {
    $.attendmanageI18n = $.attendmanageI18n || {};
    $.extend($.attendmanageI18n, {
            atsResultDynamicCommon: {
                title: 'Recalculate',
                btn_text1: 'Confirm',
                btn_text2: 'Close',
                text1: 'Re-calculation Time Clock',
                text2: 'Include Current In-working Attendance',
                text3: 'Started On',
                text4: 'End Time',
                text5: 'Request for Leave',
                text6: 'Business Trip Request',
                text7: 'Overtime Records',
                text8: 'Clock in/out Correction',
                text9: 'Time Off Confirmation',
                text10: 'Business Trip Change',
                text11: 'Documents Not Involved Calculation',
                text12: 'Calculate Attendance',
                text13: 'Time Off Period',
                text14: 'To',
                text15: 'Export',
                text16: 'Export Selected Information',
                text17: 'Export All',
                msg1: 'The submitted calculation exceeds 15,000 (person day). It may cause system slow down. Continue?',
                msg2: 'You have {0} attendance computing tasks in processing. You need to queue and wait. Continue?',
                msg3: 'You have {0} attendance computing tasks in processing. You need to queue and wait. It is recommended to submit later. Continue?',
                msg4: 'The attendance calculation start date can not be later than the end date!',
                msg5: 'The attendance calculation start date and end date are not within the current cycle scope!'
            },
            atsResultOneDayDetail: {
                text1: 'Attendance Record',
                text2: 'Review',
                text3: 'De-review',
                text4: 'Save',
                text5: 'Cancel',
                text6: 'Back',
                text7: 'Current Status :',
                text8: 'Time Card Record',
                text9: 'No time card record',
                text10: 'Absence without Reason Status',
                text11: 'Early Leave Status',
                text12: 'Time Off Information',
                text13: 'Business Trip Information',
                text14: 'Overtime Information',
                text15: 'Maintain More Information',
                text16: 'Calculate',
                text17: 'Expected Attendance Time',
                text18: 'Default Shift',
                text20: 'No attendance details',
                text21: 'None',
                text22: 'Value:',
                text23: 'Review',
                text24: 'Attendance name duplicates for line {0} and {1}',
                text25: 'Succeed',
                text26: 'Current Status :Reviewed',
                text27: 'Current Status :Calculated',
                text28: 'Calculated successfully!',
                text29: 'Calculation failed!',
                text30: 'Item',
                text31: 'Year',
                text32: 'Details',
                text33: 'Edit',
                text34: 'Save',
                text35: 'Cancel',
                text36: 'Sun',
                text37: 'Mon',
                text38: 'Tue',
                text39: 'Wed',
                text40: 'Thur',
                text41: 'Fri',
                text42: 'Sat',
                text43: 'Jan',
                text44: 'Feb',
                text45: 'Mar',
                text46: 'Apr',
                text47: 'May',
                text48: 'Jun',
                text49: 'Jul',
                text50: 'Aug',
                text51: 'Sep',
                text52: 'Oct',
                text53: 'Nov',
                text54: 'Dec',
                text55: 'Calculate Attendance',
                text56: 'Late Status',
                msg: 'Saved successfully!',
                text57: 'Approval Failed,Employee unconfirmed Attendance!'
            },
            atsResultCalBill: {
                title1: 'Request for Leave',
                title2: 'Time Card Correction',
                title3: 'Business Trip Request',
                title4: 'Overtime Records',
                msg1: 'Please select the data in the table!',
                msg2: 'Please select an employee attendance detail in the same business organization!',
                msg3: 'Absence organization {1} of {0} is not matched absence business organization {2} of current corrected document. You cannot request for leave. Please adjust.'
            },
            jqtimeline: {
                month1: 'Jan',
                month2: 'Feb',
                month3: 'Mar',
                month4: 'Apr',
                month5: 'May',
                month6: 'Jun',
                month7: 'Jul',
                month8: 'Aug',
                month9: 'Sep',
                month10: 'Oct',
                month11: 'Nov',
                month12: 'Dec',
                text1: 'To',
                text2: 'Time Off Description:',
                text3: 'Status:',
                text4: 'Applying Date:',
                text5: 'Click Right to Close:'
            },
            atsBillUtil: {
                msg1: 'You can only delete data in unsubmitted status. Please re-select!',
                msg2: 'Please select a line!',
                msg3: 'Please select a line!',
                msg4: 'Can only withdraw unapproved documents',
                msg5: 'In approval process. Do you want to withdraw?',
                msg6: 'Withdrawing successfully'
            },
            atsCommonUtile: {
                weekday1: 'Sun',
                weekday2: 'Mon',
                weekday3: 'Tue',
                weekday4: 'Wed',
                weekday5: 'Thur',
                weekday6: 'Fri',
                weekday7: 'Sat',
                alias1: 'Today',
                alias2: 'Tomorrow',
                alias3: 'This Week',
                alias4: 'Last 1 Week',
                alias5: 'Last Week',
                alias6: 'Next Week',
                alias7: 'Coming 1 Week',
                alias8: 'This Month',
                alias9: 'Latest Semi-month',
                alias10: 'Latest Month',
                alias11: 'Latest 3 Months',
                alias12: 'Last Month',
                alias13: 'Next Month',
                alias14: 'Coming 1 Month',
                alias15: 'Coming 2 Months',
                alias16: 'Coming 3 Months',
                alias17: 'Latest Semi-year',
                alias18: 'First Semi-year',
                alias19: 'Second Semi-year',
                alias20: 'This Year',
                alias21: 'Previous Year',
                alias22: 'This Quarter',
                alias23: 'Last Quarter',
                alias24: 'Customize',
                alias25: 'Server Data',
                alias26: 'Display Uncommon Data',
                alias27: 'Postpone',
                alias28: 'Replace',
                alias29: 'Not Replace',
                alias33: 'ReplaceWithShift',
                alias30: '1-Segment Shift',
                alias31: '2-Segments Shift',
                alias32: '3-Segment2 Shift',
                msg1: 'Is Empty',
                msg2: 'Incorrect format',
                msg3: 'The date does not exist for current month',
                msg4: 'Illegal date value',
                msg5: 'Not Earlier Than',
                msg6: 'Not Later Than',
                msg7: 'Start Date',
                msg8: 'End Date',
                msg9: 'The time interval between {0} and {1} cannot exceed {2} months!',
                msg10: 'The time interval between {0} and {1} cannot exceed',
                msg11: 'Millisecond',
                msg12: 'Day',
                msg13: 'Hour',
                msg14: 'Minute',
                msg15: 'Second',
                msg16: 'General F7',
                msg17: 'Please separate by commas for multi-selection',
                msg18: 'Error by creating drop-down box parameter!',
                msg19: 'Error Parameter:',
                like: 'Include',
                not_like: 'Exclude',
                equal: 'Equal to',
                not_equal: 'Not Equal to',
                gt: 'Later Than',
                lt: 'Earlier Than',
                gt_or_eq: 'Equal to or Later Than',
                lt_or_eq: 'Equal to or Earlier Than',
                yes: 'Yes',
                no: 'No',
                text1: 'Postponed scheduling means when the holiday is over, the first work day starts from the next shift that before holiday ',
                text2: 'Replaced scheduling means that according to the original schedule rule, the system will replace the holiday days to holiday date type, which no  shift information is set.',
                text3: 'Non-replaced scheduling means according to the original schedule rule, that the system will schedule the holiday days to shift',
                text4: 'Search',
                text5: 'Replacing (associated shift) shift arrangement means that the system will arrange shifts according to the original rules, replacing the date type of the legal holidays with the legal holidays, and the associated shift of the original shift arrangement will remain unchanged. If there is no shift on the rest day before the replacement, the shift must be associated with the default shift of the file, except that the date type replaces the legal holiday'
            },
            calandarWorkShift: {
                weekday1: 'Sun',
                weekday2: 'Mon',
                weekday3: 'Tue',
                weekday4: 'Wed',
                weekday5: 'Thur',
                weekday6: 'Fri',
                weekday7: 'Sat',
                month1: 'Jan',
                month2: 'Feb',
                month3: 'Mar',
                month4: 'Apr',
                month5: 'May',
                month6: 'Jun',
                month7: 'Jul',
                month8: 'Aug',
                month9: 'Sep',
                month10: 'Oct',
                month11: 'Nov',
                month12: 'Dec',
                year: 'Year',
                msg1: 'Shift Information Error:',
                msg2: 'Loading...'
            },
            listWorkShift: {
                msg1: 'Loading, please wait ...',
                msg2: 'Scheduling data is empty!',
                msg3: 'Deleting...',
                col1: 'Employee Code',
                col2: 'Name',
                col3: 'Attendance Business Organization',
                col4: 'Attendance Business Organization ID',
                col5: 'Administrative Organization',
                col6: 'Employee Relationship Status'
            },
            workShiftStrategy: {
                dayType1: 'Workday',
                dayType2: 'Rest Day',
                dayType3: 'Public Holidays',
                msg1: 'Please select row to operate on',
                msg2: 'Please select employees for shift scheduling!',
                msg3: 'Please select dates and employees for shift scheduling!',
                msg4: 'Please select employees within the same business organization',
                msg5: 'Check employees for shift scheduling!',
                msg6: 'No scheduling data to be saved, please schedule first!',
                msg7: 'Scheduled successfully!',
                msg8: 'Scheduling failed: Schedule Type {0}, Schedule Mode: {1}',
                msg9: 'Schedule in processing! Please wait...',
                title1: 'Turnover Rule',
                title2: 'Copy Shift Schedule',
                title3: 'Select Date Type & Shift',
                text: 'To',
                label1: 'Name',
                label2: 'Attendance Date',
                label3: 'Error Details'
            },
            atsHolidayFileHISMultiRow: {
                msg1: 'Note: Adding or modifying attendance file history will not update the completed business data. Example: An employee has been scheduled. When the attendance organization file history is modified, if you want to apply the modified attendance organization to shift scheduling, you need to re-schedule the employee’s shift.',
                msg2: 'All fields of file history cannot be empty!',
                msg3: 'The effective and expired dates must be continuous and not overlapped!',
                msg4: 'The effective date can not be later than the current date!',
                msg5: 'The effective and expired dates of the file history cannot be later than those of previous file history!',
                msg6: 'The effective and the expired date cannot overlap!'
            },
            attendanceFileHISMultiRow: {
                msg1: 'Note: Adding or modifying attendance file history will not update the completed business data. Example: An employee has been scheduled. When the attendance organization file history is modified, if you want to apply the modified attendance organization to shift scheduling, you need to re-schedule the employee’s shift.',
                msg2: 'All fields of file history cannot be empty!',
                msg3: 'The effective and expired dates must be continuous and not overlapped!',
                msg4: 'The effective date can not be later than the current date!',
                msg5: 'The effective and expired dates of the file history cannot be later than those of previous file history!',
                msg6: 'The effective and the expired date cannot overlap!'
            },
            dateYearMonthPicker: {
                year: 'Year',
                month: 'Month'
            },
	    	commonRes:{
	    		calendar:"Work Calendar"
	    	}
        }
    )
})(jQuery);	