package com.kingdee.shr.affair.web.handler.hrman;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.base.permission.util.ToolUtils;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.custom.shengshen.utils.EnrollFileUtil;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillCollection;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryCollection;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryFactory;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryInfo;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillFactory;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillInfo;
import com.kingdee.eas.hr.affair.IEmpEnrollBizBill;
import com.kingdee.eas.hr.affair.IEmpEnrollBizBillEntry;
import com.kingdee.shr.affair.web.handler.hrman.EmpEnrollBizBillHrManListHandler;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.util.StringUtils;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.SQLException;
import java.text.ParseException;
import java.util.*;


/**
 * 入职流程
 * @author Administrator
 * 202409
 */
public class EmpEnrollBizBillHrManListHandlerEx extends EmpEnrollBizBillHrManListHandler {

	
	
	public void getRegisterFileAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException, BOSException, SQLException, ParseException {
		// 填充数据
		
		Context ctx = getContext();
		String[] billIds = StringUtils.cnulls(request.getParameter("billIds")).split(",");
		
		IEmpEnrollBizBillEntry enroIns = EmpEnrollBizBillEntryFactory.getLocalInstance(ctx);
		 //
		 EntityViewInfo entityViewInfo = new EntityViewInfo();
		 SelectorItemCollection selectCol = new SelectorItemCollection();
		 selectCol.add(new SelectorItemInfo("person"));
		 entityViewInfo.setSelector(selectCol);
		  FilterInfo filterInfo = new FilterInfo();
		  filterInfo.getFilterItems().add( new FilterItemInfo("bill",ToolUtils.aryToStr(billIds,false),CompareType.INCLUDE  ) );
		 entityViewInfo.setFilter(filterInfo );
		   EmpEnrollBizBillEntryCollection empEnrollCol = enroIns.getEmpEnrollBizBillEntryCollection(entityViewInfo);
		 Set<String> personSet = new HashSet();
		 for(int i = 0;i<empEnrollCol.size(); i++ ) {
			 EmpEnrollBizBillEntryInfo empEnrollBizBillInfo = empEnrollCol.get(i);
			 PersonInfo applier = empEnrollBizBillInfo.getPerson();
			 if( null != applier) {
				 String personId = StringUtils.cnulls(applier.getId());
				 personSet.add(personId);
			 }
		 }
		 String link = EnrollFileUtil. createPDFFile( request,ctx, personSet );
		 writeSuccessData(link);
		 
	} 
	

	
	
	
}
