package com.kingdee.eas.custom.ssPDF.utils;

import com.itextpdf.text.pdf.*;
import com.kingdee.bos.BOSException;
//import net.lingala.zip4j.ZipFile;
import net.lingala.zip4j.exception.ZipException;
import net.lingala.zip4j.model.ZipParameters;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class PDFFillInformationUtil {
    /**
     * pdf
     * @param file ԭʼļ
     * @param field map<String,String> key Ϊֶvalue Ϊֵ
     * @return ļ  ļΪbyte[]
     */
    public File fillInformation(byte[] file, Map<String,String> field,String tempFilePath,String fileName) throws IOException {
        try {
            System.setProperty("javax.xml.parsers.DocumentBuilderFactory","com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl");
            // ȡPDFģ
            PdfReader pdfReader = new PdfReader(file);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            // ͸PDFļ
            PdfStamper pdfStamper = new PdfStamper(pdfReader, baos);
            AcroFields form = pdfStamper.getAcroFields();
            BaseFont bf = BaseFont.createFont("c:/windows/fonts/SIMSUN.TTC,1",BaseFont.IDENTITY_H, BaseFont.NOT_EMBEDDED);// ֶ
            ArrayList<BaseFont> fontList = new ArrayList<BaseFont>();
            fontList.add(bf);
            form.setSubstitutionFonts(fontList);
            Iterator<Map.Entry<String, String>> iterator = field.entrySet().iterator();

            while (iterator.hasNext()) {
                Map.Entry<String, String> entry = iterator.next();
                String key = entry.getKey();
                String value = entry.getValue();
                //ֵֶ
                form.setField(key, value);
                //form.setFieldProperty(key, "setflags", PdfFormField.MARKUP_HIGHLIGHT, null);

            }
            //ɺpdf ڱ༭
            pdfStamper.setFormFlattening(false);
            // ر޸ͷԴ
            pdfStamper.close();
            pdfReader.close();
            File outFile = new File(tempFilePath+"/"+fileName);
//            if (!outFile.createNewFile()) {
//                throw new RuntimeException("pdf ʧܣ");
//            }
            if (!(outFile.exists())) {
                outFile.createNewFile();
            } else {
                outFile.delete();
                outFile.createNewFile();
            }

            FileOutputStream fos = new FileOutputStream(outFile);
            baos.writeTo(fos);
            fos.close(); // رͷԴ
            return  outFile;
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("pdf ʧܣ");
        }
    }
    /**
     * ѹ
     *
     * @param destFileName
     * @param files
     * @return
     */
//    public static String compress(String destFileName, List<File> files) throws BOSException {
//        ZipParameters parameters = new ZipParameters();
//        //parameters.setCompressionMethod(8);
//        //parameters.setCompressionLevel(5);
//        try {
//            ZipFile zipFile = new ZipFile(destFileName);
//            for (int i = 0; i < files.size(); ++i) {
//                File file = files.get(i);
//                zipFile.addFile(file, parameters);
//            }
//            return destFileName;
//        } catch (ZipException var9) {
//            var9.printStackTrace();
//            throw new BOSException(var9.getMessage());
//        }
//    }
}
